Option Explicit
On Error Resume Next

Dim arrMonth_Days
Dim Prev_Action
Dim Action
Dim DBActionDay
Dim DBActionMonth
Dim DayItemList
Dim MonthItemList
Dim MissedItemList
Dim MissedEventCount
Dim Status
Dim ItemNr()
Dim Jaar()
Dim Maand()
Dim Dag()
Dim Uur()
Dim Minuut()
Dim EventItem()
Dim Comment()
Dim Repeat()
Dim Acknowledge()
Dim TotalEventLines

arrMonth_Days = Array( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 )


'-------------------------------------------------------
'- Main ------------------------------------------------
'-------------------------------------------------------
'- Parse ontvangen commando en roep juiste functie aan -
'-------------------------------------------------------
Do
	Sleep 1
	Action = GetPropertyValue ("Agenda.Action")
	If Action <> "Waiting" Then
		SetPropertyValue "Agenda.Action", "Waiting"
		Status           = ""
		MissedEventCount = 0
		Prev_Action      = GetPropertyValue ("Agenda.Previous Action")
		
		'Onderstaande If zorgt ervoor dat er geen acties uitgevoerd zolang Delete Item Requester in beeld is
		' De Enter List van de Delete Requester zet Prev_Action en Action op "Del_Item"
		' De Exit List van de Delete Requester zet Prev_Action op "No_Action"
		' De OK button van de Delete Requester zet Action op "Delete_Item"
		' Als de Requester verschijnt, werkt Action = "Del_Item"
		' Met de Requester in beeld werkt niets behalve Action = "Delete_Item"
		' Zonder Requester werkt alles omdat Prev_Action <> "Del_Item"
		If Prev_Action <> "Del_Item" or Action = "Del_Item" or Action = "Delete_Item" Then
			Select Case True
				Case Left(Action, 5)  = "Year_"          : Call Set_Year(Action)
				Case Left(Action, 6)  = "Month_"         : Call Set_Month(Action)
				Case Left(Action, 7)  = "Button_"        : Call Calc_Day(Action)
				Case Left(Action, 5)  = "Icon_"          : Call Clear_IconAndEvent(Action)
				Case Action           = "SetMonthItemDay": Call Set_MonthItemDay()
				Case Action           = "Del_Item"       : Call Check_Delete_Item()
				Case Action           = "Delete_Item"    : Call Delete_Item(Action)
				Case Action           = "Panel_Entry"    : Call Panel_Entry()
				Case Action           = "Today"          : Call Set_Today()
				Case Action           = "Check"          : Call Check_ItemList(GetPropertyValue ("Agenda.Year"), GetPropertyValue ("Agenda.Month"), GetPropertyValue ("Agenda.Day"))
				Case Action           = "Clear_EventList": Call Clear_MissedItemList()
				Case Action           = "GUI_Edit_Item"  : Call GUI_Edit_Item()
				Case Action           = "GUI_New_Item"   : Call GUI_New_Item(False)
				Case Left(Action, 9)  = "GUI_Hour_"      : Call GUI_Hour(Action)
				Case Left(Action, 11) = "GUI_Minute_"    : Call GUI_Minute(Action)
				Case Left(Action, 9)  = "GUI_Item_"      : Call GUI_Item(Action)
				Case Left(Action, 11) = "GUI_Repeat_"    : Call GUI_Repeat(Action)
			End Select
			
			SetPropertyValue "Agenda.Status", Status
		End If
	End If
	
	DBActionDay = GetPropertyValue("Agenda.DB Action Day")
	If DBActionDay <> "Waiting" Then
		SetPropertyValue "Agenda.DB Action Day", "Waiting"
		Sleep 100

		If DBActionDay <> "" Then
			OpenRemotePanel("Agenda Item GUI") 'This can cause problems while using remote swremotes
		End If
	End If
	
	DBActionMonth = GetPropertyValue("Agenda.DB Action Month")
	If DBActionMonth <> "Waiting" Then
		SetPropertyValue "Agenda.DB Action Month", "Waiting"
		Sleep 100

		If DBActionMonth <> "" Then
			Call Set_MonthItemDay()
		End If
	End If
Loop


'-------------------------------------------------------
'- Agenda Functies -------------------------------------
'-------------------------------------------------------
'- Verwerk vandaag en set Icons. Panel entry -----------
'-------------------------------------------------------
Sub Panel_Entry()

	'Bij entry van Agenda Panel wordt Panel_Entry in Action gezet. Vanuit het Info Panel moet Today worden gezet
	' Als de GUI sluit, wordt het Agenda Panel ook voorgezet en wordt Panel_Entry in Action gezet. Nu moet Today
	' niet worden gezet, maar moet het GUI_Close_Panel() worden uitgevoerd

	If GetPropertyValue ("Agenda.Previous Action") = "GUI_Close_Panel" Then
		SetPropertyValue "Agenda.Previous Action", ""
		Call GUI_Close_Panel()
	Else
		'Call Refresh_Icons()
		Call Set_Today()
	End If
End Sub


'-------------------------------------------------------
'- Verwerk het geselecteerde jaar ----------------------
'-------------------------------------------------------
Sub Set_Year(Action)
Dim Jaar
Dim Maand
Dim Data
Dim Datum

	Jaar  = GetPropertyValue ("Agenda.Year")
	Maand = GetPropertyValue ("Agenda.Month")
	Data  = Split(Action, "_")
	Select Case Data(1)
		Case "Prev": Datum = DateSerial(Jaar - 1, Maand, 1)
		Case "Next": Datum = DateSerial(Jaar + 1, Maand, 1)
		Case Else  : Datum = DateSerial(CInt(Data(1)), 1, 1)
	End Select

	Maand = Month(Datum)
	Jaar  = Year(Datum)
	SetpropertyValue "Agenda.Year", Jaar
	SetpropertyValue "Agenda.Month", Maand
	SetPropertyValue "Agenda.Day", 1
	Call Set_Month_Image(Jaar, Maand, 1)
End Sub


'-------------------------------------------------------
'- Verwerk de geselecteerde maand ----------------------
'-------------------------------------------------------
Sub Set_Month(Action)
Dim Jaar
Dim Maand
Dim Data
Dim Datum

	Jaar  = GetPropertyValue ("Agenda.Year")
	Maand = GetPropertyValue ("Agenda.Month")
	Data  = Split(Action, "_")
	Select Case Data(1)
		Case "Prev": Datum = DateSerial(Jaar, Maand - 1, 1)
		Case "Next": Datum = DateSerial(Jaar, Maand + 1, 1)
		Case Else  : Datum = DateSerial(Jaar, CInt(Data(1)), 1)
	End Select

	Maand = Month(Datum)
	Jaar  = Year(Datum)
	SetpropertyValue "Agenda.Year", Jaar
	SetPropertyValue "Agenda.Month", Maand
	SetPropertyValue "Agenda.Day", 1
	Call Set_Month_Image(Jaar, Maand, 1)
End Sub

'-------------------------------------------------------
'- Verwerk vandaag. Door Theme Button 'Vandaag' --------
'-------------------------------------------------------
Sub Set_Today()

	SetPropertyValue "Agenda.Year", Year(Now)
	SetPropertyValue "Agenda.Month", Month(Now)
	SetPropertyValue "Agenda.Day", Day(Now)
	Call Set_Month_Image(Year(Now), Month(Now), Day(Now))
End Sub


'-------------------------------------------------------
'- Bepaal welke dag van de maand is geselecteerd -------
'-------------------------------------------------------
Sub Calc_Day(Action)
Dim Jaar
Dim Maand
Dim Dag
Dim AantalDagen
Dim FirstDayOfMonth
Dim Offset

	Jaar  = GetPropertyValue ("Agenda.Year")
	Maand = GetPropertyValue ("Agenda.Month")
	If Jaar mod 4 = 0 and Maand = 2 Then
		AantalDagen = 29 'Schikkeljaar
	Else
		AantalDagen = arrMonth_Days(Maand - 1)
	End If

	FirstDayOfMonth = Weekday(DateSerial(Jaar, Maand, 1))
	If FirstDayOfMonth = 1 Then 'Zondag is de eerste dag van de maand. Compenseren voor NL systeem
		Offset = 6 'Eerste dag van de maand begint onder Button_6
	Else
		Offset = FirstDayOfMonth - 2
	End If

	Dag = CInt(Right(Action, 2)) - Offset
	If Dag >= 1 and Dag <= AantalDagen Then
		SetPropertyValue "Agenda.Day", Dag
		Call Check_ItemList(Jaar, Maand, Dag)
	End If
End Sub


'-------------------------------------------------------
'- Bepaal welke dag uit de Month log is geselecteerd ---
'-------------------------------------------------------
Sub Set_MonthItemDay()
Dim Datum
Dim SelectedItemLine

	SelectedItemLine = GetPropertyValue ("Agenda.Month Log Selected Item Line")
	Datum            = Split(SelectedItemLine, "#") 'Datum(0) = ItemNr
	If IsNumeric(Datum(0)) = True Then 'Kijk of er een item is geselecteerd
		SetPropertyValue "Agenda.Year", Datum(1)
		SetPropertyValue "Agenda.Month", Datum(2)
		SetPropertyValue "Agenda.Day", Datum(3)
		Call Check_ItemList(Datum(1), Datum(2), Datum(3))
	End If
End Sub


'-------------------------------------------------------
'- Bepaal de juiste image voor de maand  en de weeknrs -
'-------------------------------------------------------
Sub Set_Month_Image(Jaar, Maand, Dag)
Dim Week
Dim FileSystem
Dim PicturePath
Dim PictureName
Dim Picture
Dim Offset
Dim AantalDagen

	Set FileSystem = CreateObject("Scripting.FileSystemObject")

	If Jaar mod 4 = 0 and Maand = 2 Then
		AantalDagen = 29 'Schikkeljaar
	Else
		AantalDagen = arrMonth_Days(Maand - 1)
	End If

	'Deze If en de -2 hieronder zijn nodig om voor het NL systeem te compenseren. In NL begint de week op maandag	
	Offset = Weekday(DateSerial(Jaar, Maand, 1)) - 2
	If Offset < 0 Then
		Offset = 6
	End If

	PicturePath = GetPropertyValue ("Agenda.Picture Path") & "\"
	PictureName = "Month_" & Offset & AantalDagen & ".png"
	Picture     = PicturePath & PictureName
	If FileSystem.FileExists(Picture) = False Then
		Picture = PicturePath & "Month_Empty.png"
	End If
	
	Set FileSystem = Nothing
	SetPropertyValue "Agenda.Month Image", Picture

	For Week = 1 to 6
		If Week = 5 and Offset = 0 and Aantaldagen = 28 Then
			SetPropertyValue "Agenda.Week 5", ""
		Else
			If Week < 6 or (Week = 6 and ((Offset = 5 and Aantaldagen = 31) or (Offset = 6 and Aantaldagen >= 30))) Then
				SetPropertyValue "Agenda.Week " & Week, DatePart("ww", DateSerial(Jaar, Maand, ((Week - 1) * 7) + 1) , vbMonday, vbFirstFourDays)
			Else
				SetPropertyValue "Agenda.Week 6", ""
			End If
		End If
	Next

	Call Check_ItemList(Jaar, Maand, Dag)
End Sub


'-------------------------------------------------------
'- Check of er items aanwezig zijn en vul de listviews -
'-------------------------------------------------------
Sub Check_ItemList(SetJaar, SetMaand, SetDag)
Dim nit

	DayItemList     = "Geen items voor deze dag"
	MonthItemList   = "Geen items in deze maand"
	MissedItemList  = "Geen gemiste items aanwezig"
	TotalEventLines = Read_ItemList()

	If TotalEventLines >= 0 Then
		For nit = 0 to TotalEventLines
			Call MonthItemLog(CInt(SetJaar), CInt(SetMaand), CInt(ItemNr(nit)), CInt(Jaar(nit)), CInt(Maand(nit)), CInt(Dag(nit)), CInt(Uur(nit)), CInt(Minuut(nit)), EventItem(nit))
			Call DayItemLog(CInt(SetJaar), CInt(SetMaand), CInt(SetDag), CInt(ItemNr(nit)), CInt(Jaar(nit)), CInt(Maand(nit)), CInt(Dag(nit)), CInt(Uur(nit)), CInt(Minuut(nit)), EventItem(nit), Comment(nit))
			Call MissedItemLog(CInt(ItemNr(nit)), CInt(Jaar(nit)), CInt(Maand(nit)), CInt(Dag(nit)), CInt(Uur(nit)), CInt(Minuut(nit)), EventItem(nit), Comment(nit), Acknowledge(nit))
		Next	
	End If
	
	SetPropertyValue "Agenda.Current Day", FormatDateTime(DateSerial(SetJaar, SetMaand, SetDag), 1)
	SetPropertyValue "Agenda.Log Agenda Daily Items", DayItemList
	SetPropertyValue "Agenda.Log Agenda Monthly Items", MonthItemList
	SetPropertyValue "Agenda.Log Agenda Missed Events", MissedItemList
	SetPropertyValue "Agenda.Event Count", MissedEventCount
End Sub


'-------------------------------------------------------
'- Check of er items aanwezig zijn voor de Month Log ---
'-------------------------------------------------------
Sub MonthItemLog(SetJaar, SetMaand, ItemNr, Jaar, Maand, Dag, Uur, Minuut, EventItem)
Dim DateTime

	If SetJaar = Jaar and SetMaand = Maand Then

		If MonthItemList = "Geen items in deze maand" Then
			MonthItemList = ""
		End If

		Uur           = L_Pad(Uur, 2, "0")
		Minuut        = L_Pad(Minuut, 2, "0")
		DateTime      = FormatDateTime(DateSerial(Jaar, Maand, Dag), 1) & " - " & Uur & ":" & Minuut
		MonthItemList = MonthItemList & ItemNr & "#" & Jaar & "#" & Maand & "#" & Dag & "#" & EventItem & vbTAB & DateTime & vbTAB & EventItem & vbLF
	End If
End Sub


'-------------------------------------------------------
'- Check of er items aanwezig zijn voor de Day Log -----
'-------------------------------------------------------
Sub DayItemLog(SetJaar, SetMaand, SetDag, ItemNr, Jaar, Maand, Dag, Uur, Minuut, EventItem, Comment)
Dim DateTime

	If SetJaar = Jaar and SetMaand = Maand and SetDag = Dag Then
		If DayItemList = "Geen items voor deze dag" Then
			DayItemList = ""
		End If

		Uur         = L_Pad(Uur, 2, "0")
		Minuut      = L_Pad(Minuut, 2, "0")
		DateTime    = FormatDateTime(DateSerial(Jaar, Maand, Dag), 1) & " - " & Uur & ":" & Minuut
		DayItemList = DayItemList & ItemNr & "#" & Jaar & "#" & Maand & "#" & Dag & "#" & Uur & "#" & _
					    Minuut & "#" & EventItem & "#" & Comment & "#" & Repeat(ItemNr) & _
					    vbTAB & DateTime & vbTAB & EventItem & vbTAB & Comment & vbLF
	End If
End Sub


'-------------------------------------------------------
'- Check of er items aanwezig zijn voor de Missed Log --
'-------------------------------------------------------
Sub MissedItemLog(ItemNr, Jaar, Maand, Dag, Uur, Minuut, EventItem, Comment, Acknowledge)
Dim DateTime

	If Acknowledge = 0 Then
		If DateSerial(Jaar, Maand, Dag) < Date or (DateSerial(Jaar, Maand, Dag) = Date and TimeSerial(Uur, Minuut, 0) <= Time) Then
			If MissedItemList = "Geen gemiste items aanwezig" Then
				MissedItemList = ""
			End If
                	
			Uur              = L_Pad(Uur, 2, "0")
			Minuut           = L_Pad(Minuut, 2, "0")
			MissedEventCount = MissedEventCount + 1
			DateTime         = FormatDateTime(DateSerial(Jaar, Maand, Dag), 1) & " - " & Uur & ":" & Minuut
			MissedItemList   = MissedItemList & vbTAB & DateTime & vbTAB & EventItem & vbTAB & Comment & vbLF
			Call Set_Icon(EventItem)
		End If
	End If
End Sub


'-------------------------------------------------------
'- Clear missed events item list -----------------------
'-------------------------------------------------------
Sub Clear_MissedItemList()
Dim PicturePath
Dim IconValue
Dim nit

	PicturePath     = GetPropertyValue ("Agenda.Picture Path") & "\"
	TotalEventLines = Read_ItemList()
	If TotalEventLines >= 0 Then	
		For nit = 0 To TotalEventLines 
			If DateSerial(Jaar(nit), Maand(nit), Dag(nit)) < Date or (DateSerial(Jaar(nit), Maand(nit), Dag(nit)) = Date and TimeSerial(Uur(nit), Minuut(nit), 0) <= Time) Then
				Acknowledge(nit) = Set_Repeat(nit)
			End If
		Next
		
		Call Write_ItemList()
		Call Check_ItemList(GetPropertyValue ("Agenda.Year"), GetPropertyValue ("Agenda.Month"), GetPropertyValue ("Agenda.Day"))
		PicturePath = PicturePath & "Icon_Empty.png"
		For nit = 1 to 8
			IconValue = "Agenda.Icon " & nit
			SetPropertyValue IconValue, PicturePath
		Next
	End If
End Sub


'-------------------------------------------------------
'- Verwijder juiste icon en bijbehorende missed item ---
'-------------------------------------------------------
Sub Clear_IconAndEvent(Action)
Dim IconValue
Dim Picture
Dim EventItemLine
Dim nit
	
	Select Case Right(Action, 1)
		Case 1: EventItemLine = "Wekker"
		Case 2: EventItemLine = "Verjaardag"
		Case 3: EventItemLine = "Groen container"
		Case 4: EventItemLine = "Grijze container"
		Case 5: EventItemLine = "Afspraak thuis"
		Case 6: EventItemLine = "Afspraak"
		Case 7: EventItemLine = "Meterstanden"
		Case 8: EventItemLine = "Feestdagen"
	End Select

	TotalEventLines = Read_ItemList()
	If TotalEventLines >= 0 Then
		For nit = 0 To TotalEventLines 
			If DateSerial(Jaar(nit), Maand(nit), Dag(nit)) < Date or (DateSerial(Jaar(nit), Maand(nit), Dag(nit)) = Date and TimeSerial(Uur(nit), Minuut(nit), 0) <= Time) Then
				If EventItem(nit) = EventItemLine Then
					Acknowledge(nit) = Set_Repeat(nit)
				End If
			End If
		Next
		
		Call Write_ItemList()
		Call Check_ItemList(GetPropertyValue ("Agenda.Year"), GetPropertyValue ("Agenda.Month"), GetPropertyValue ("Agenda.Day"))
		IconValue = "Agenda.Icon " & Right(Action, 1)
		Picture   = GetPropertyValue ("Agenda.Picture Path") & "\Icon_Empty.png"
		SetPropertyValue IconValue, Picture
	End If
End Sub


'-------------------------------------------------------
'- Check if an Item is selected for deletion -----------
'-------------------------------------------------------
Sub Check_Delete_Item()
Dim ItemNumber

	ItemNumber = Split(GetPropertyValue("Agenda.Month Log Selected Item Line"), "#")
	If IsNumeric(ItemNumber(0)) <> True Then 'ItemNr wordt hier gefiltered.
		CloseRemotePanel ("Agenda Del Pop")
		Status = "Geen item geselecteerd!"
	Else
		SetPropertyValue "Agenda.Month Log Selected Delete Item", ItemNumber(4)
		'Status = FormatDateTime(DateSerial(ItemNumber(1), ItemNumber(2), ItemNumber(3)), 1) & " " & ItemNumber(4)
	End If
End Sub


'-------------------------------------------------------
'- Delete Item from item list --------------------------
'-------------------------------------------------------
Sub Delete_Item(Action)
Dim ItemNumber

	CloseRemotePanel ("Agenda Del Pop")
	TotalEventLines = Read_ItemList()
	ItemNumber      = Split(GetPropertyValue("Agenda.Month Log Selected Item Line"), "#")
	If IsNumeric(ItemNumber(0)) = True Then 'ItemNr wordt hier gefiltered.
		ItemNr(ItemNumber(0)) = -1 'Bij -1 wordt de betreffende Item regel niet meegenomen in de Write_ItemList() functie
		Call Write_ItemList()
		Call Check_ItemList(GetPropertyValue ("Agenda.Year"), GetPropertyValue ("Agenda.Month"), GetPropertyValue ("Agenda.Day"))
	End If
End Sub

'-------------------------------------------------------
'- Set Icon in dynamic image ---------------------------
'-------------------------------------------------------
Sub Set_Icon(EventItem)
Dim FileSystem
Dim Picture
Dim IconValue

	Select Case EventItem
		Case "Wekker"          : IconValue = "Agenda.Icon 1"
		Case "Verjaardag"      : IconValue = "Agenda.Icon 2"
		Case "Groen container" : IconValue = "Agenda.Icon 3"
		Case "Grijze container": IconValue = "Agenda.Icon 4"
		Case "Afspraak thuis"  : IconValue = "Agenda.Icon 5"
		Case "Afspraak"        : IconValue = "Agenda.Icon 6"
		Case "Meterstanden"    : IconValue = "Agenda.Icon 7"
		Case "Feestdagen"      : IconValue = "Agenda.Icon 8"
	End Select

	Set FileSystem = CreateObject("Scripting.FileSystemObject")
	Picture        = GetPropertyValue ("Agenda.Picture Path") & "\Icon_" & Eventitem & ".png"
	If FileSystem.FileExists(Picture) = False Then
		Picture = GetPropertyValue ("Agenda.Picture Path") & "\Icon_Empty.png"
	End If
	
	SetPropertyValue IconValue, Picture
	Set FileSystem = Nothing
End Sub


'-------------------------------------------------------
'- Als er een repeat is, wordt een nieuw item gemaakt --
'-------------------------------------------------------
Function Set_Repeat(EventItem) '0 = Geen, 1 = Uur, 2 = Dag, 3 = Week, 4 = 2 Weken, 5 = Maand, 6 = jaar
Dim RepeatDate

	Set_Repeat = 0 'Bij Repeats groter dan 0, moet Acknowledge niet worden gezet zodat het Item opnieuw op kan komen
	RepeatDate = DateSerial(Jaar(EventItem), Maand(EventItem), Dag(EventItem))
	
	Select Case Repeat(EventItem)
		Case 0: Set_Repeat     = 1 'Hierdoor wordt de Acknowledge waarde gezet en het item verwijderd
		Case 1: Uur(EventItem) = Uur(EventItem) + 1
			If CInt(Uur(EventItem)) > 23 Then
				Uur(EventItem) = 0
				RepeatDate     = DateSerial(Jaar(EventItem), Maand(EventItem), Dag(EventItem) + 1)
			End If
		Case 2: RepeatDate = DateSerial(Jaar(EventItem),     Maand(EventItem),     Dag(EventItem) + 1)
		Case 3: RepeatDate = DateSerial(Jaar(EventItem),     Maand(EventItem),     Dag(EventItem) + 7)
		Case 4: RepeatDate = DateSerial(Jaar(EventItem),     Maand(EventItem),     Dag(EventItem) + 14)
		Case 5: RepeatDate = DateSerial(Jaar(EventItem),     Maand(EventItem) + 1, Dag(EventItem))
		Case 6: RepeatDate = DateSerial(Jaar(EventItem) + 1, Maand(EventItem),     Dag(EventItem))
	End Select

	Dag(EventItem)   = Day(RepeatDate)
	Maand(EventItem) = Month(RepeatDate)
	Jaar(EventItem)  = Year(RepeatDate)
	If CInt(Jaar(EventItem)) > 2012 Then
		Jaar(EventItem) = 2012
		Set_Repeat      = 0 'Hier is het einde van de kalender bereikt. Het item wordt verwijderd om errors te voorkomen
	End If
End Function


'-------------------------------------------------------
'- Commonly used Functions -----------------------------
'-------------------------------------------------------
'- Format Data (Hour etc) to include leading 0's -------
'-------------------------------------------------------
Function L_Pad(Data, Length, Char)

	L_Pad = String(Length - Len(Data), Char) & Data
End Function


'-------------------------------------------------------
'- Refresh Icons ---------------------------------------
'-------------------------------------------------------
Sub Refresh_Icons()
Dim nit

	For nit = 1 to 8
		If Right(GetpropertyValue ("Agenda.Icon " & nit), 9) = "Empty.png" Then
			SetPropertyValue "Agenda.Icon " & nit, GetPropertyValue ("Agenda.Picture Path") & "\Icon_Empty.png"
		End If
	Next     
End Sub


'-------------------------------------------------------
'- Read item list --------------------------------------
'-------------------------------------------------------
Function Read_ItemList()

On Error Resume Next

Dim FileSystem
Dim StdIn
Dim FileName
Dim objRE
Dim strContent
Dim colLines
Dim Data
Dim NextTriggerItemFlag
Dim TriggerDateTime

	NextTriggerItemFlag = False
	FileName            = GetPropertyValue ("Agenda.ItemList Path")
	Set FileSystem      = CreateObject("Scripting.FileSystemObject")
	Set StdIn           = FileSystem.OpenTextFile(FileName, 1)
	strContent          = StdIn.ReadAll

	If Err.Number = 0 Then
		Set objRE       = New RegExp
		objRE.Global    = True
		objRE.Pattern   = ("\n")
		Set colLines    = objRE.Execute(strContent)
		TotalEventLines = colLines.count + 1
	
		ReDim ItemNr(TotalEventLines)
		ReDim Jaar(TotalEventLines)
		ReDim Maand(TotalEventLines)
		ReDim Dag(TotalEventLines)
		ReDim Uur(TotalEventLines)
		ReDim Minuut(TotalEventLines)
		ReDim EventItem(TotalEventLines)
		ReDim Comment(TotalEventLines)
		ReDim Repeat(TotalEventLines)
		ReDim Acknowledge(TotalEventLines)
		StdIn.Close

		Set StdIn       = Nothing
		Set StdIn       = FileSystem.OpenTextFile(FileName, 1)
		TotalEventLines = 0
		Do Until StdIn.AtEndOfStream
			Data                         = Split(StdIn.ReadLine, "#")
			ItemNr(TotalEventLines)      = Data(0)
			Jaar(TotalEventLines)        = Data(1)
			Maand(TotalEventLines)       = Data(2)
			Dag(TotalEventLines)         = Data(3)
			Uur(TotalEventLines)         = Data(4)
			Minuut(TotalEventLines)      = Data(5)
			EventItem(TotalEventLines)   = Data(6)
			Comment(TotalEventLines)     = Data(7)
			Repeat(TotalEventLines)      = Data(8)
			Acknowledge(TotalEventLines) = Data(9)

			'Onderstaande zet de datum en tijd van het eerst volgende Item dat triggered in een property
			' zodat de task die het script runt om items te checken alleen op de juiste tijden checked!
			If NextTriggerItemFlag = False and Acknowledge(TotalEventLines) = 0 Then
				If DateSerial(Jaar(TotalEventLines), Maand(TotalEventLines), Dag(TotalEventLines)) > Date or _
				  (DateSerial(Jaar(TotalEventLines), Maand(TotalEventLines), Dag(TotalEventLines)) = Date and _
				   TimeSerial(Uur(TotalEventLines), Minuut(TotalEventLines), 0) > Time) Then
					NextTriggerItemFlag = True
					TriggerDateTime = "Year=" & Jaar(TotalEventLines) & ",Month=" & L_Pad(Maand(TotalEventLines), 2, "0") & _
							  ",Day=" & Dag(TotalEventLines)  & ",Hour="  & Uur(TotalEventLines) & ",Minute=" & Minuut(TotalEventLines)
					SetPropertyValue "Agenda.Next Trigger Time", TriggerDateTime
				End If
			End If
			TotalEventLines = TotalEventLines + 1
		Loop
		StdIn.Close
		Read_ItemList = TotalEventLines - 1
	Else
		ReDim ItemNr(1) 'Minimaal 1 in de array zetten zodat er een nieuw item aangemaakt kan worden
		ReDim Jaar(1)
		ReDim Maand(1)
		ReDim Dag(1)
		ReDim Uur(1)
		ReDim Minuut(1)
		ReDim EventItem(1)
		ReDim Comment(1)
		ReDim Repeat(1)
		ReDim Acknowledge(1)
		
		Read_ItemList = -1
		
		If Err.Number = 62 Then 'Invoer voorbij bastandseinde
			Status = "Geen items aanwezig in de lijst!"
		Else
			Status = Err.Description
		End If
		Err.Clear
	End If

	Set colLines   = Nothing
	Set objRE      = Nothing
	Set StdIn      = Nothing
	Set FileSystem = Nothing
End Function


'-------------------------------------------------------
'- Write item list -------------------------------------
'-------------------------------------------------------
Sub Write_ItemList()
Dim FileSystem
Dim StdOut
Dim FileName
Dim ItemLine
Dim ItemNumber
Dim nit

	Call Sort_ItemList()

	On Error Resume next

	FileName       = GetPropertyValue ("Agenda.ItemList Path")
	Set FileSystem = CreateObject("Scripting.FileSystemObject")	
	Set StdOut     = FileSystem.OpenTextFile(FileName, 2, True)

	If Err.Number = 0 Then
		ItemNumber = 0
		For nit = 0 to TotalEventLines
			If ItemNr(nit) <> -1 Then 'Een ItemNr met -1 moet worden gedelete. Niet mee saven in deze loop!				
				ItemLine = ItemNumber  & "#" & Jaar(nit)   & "#" & Maand(nit)     & "#" & Dag(nit)     & "#" & _
					   Uur(nit)    & "#" & Minuut(nit) & "#" & EventItem(nit) & "#" & Comment(nit) & "#" & _
				   	   Repeat(nit) & "#" & Acknowledge(nit)  & vbCRLF
				StdOut.Write ItemLine
				ItemNumber = ItemNumber + 1 'Hierdoor lopen de Itemnummers goed op bij een deleted item
			End If
		Next
		StdOut.Close
		Status = "" 'Deze staat hier zodat een eventuele Read_Item status error wordt gecleared na deze write
	Else
		Status = Err.Description
		Err.Clear
	End If

	Set StdOut     = Nothing
	Set FileSystem = Nothing
End Sub


'-------------------------------------------------------
'- Sort item list --------------------------------------
'-------------------------------------------------------
Sub Sort_ItemList()
Dim nit
Dim nic
Dim Data1
Dim Data2
Dim Temp

	For nit = 0 to TotalEventLines
		For nic = nit + 1 to TotalEventLines
			Data1 = Jaar(nic) & L_Pad(Maand(nic), 2, "0") & L_Pad(Dag(nic), 2, "0") & Uur(nic) & Minuut(nic)
			Data2 = Jaar(nit) & L_Pad(Maand(nit), 2, "0") & L_Pad(Dag(nit), 2, "0") & Uur(nit) & Minuut(nit)
			
			If Data1 < Data2 Then
				Temp             = ItemNr(nic)
				ItemNr(nic)      = ItemNr(nit)
				ItemNr(nit)      = Temp
				Temp             = Jaar(nic)
				Jaar(nic)        = Jaar(nit)
				Jaar(nit)        = Temp
				Temp             = Maand(nic)
				Maand(nic)       = Maand(nit)
				Maand(nit)       = Temp
				Temp             = Dag(nic)
				Dag(nic)         = Dag(nit)
				Dag(nit)         = Temp
				Temp             = Uur(nic)
				Uur(nic)         = Uur(nit)
				Uur(nit)         = Temp
				Temp             = Minuut(nic)
				Minuut(nic)      = Minuut(nit)
				Minuut(nit)      = Temp
				Temp             = EventItem(nic)
				EventItem(nic)   = EventItem(nit)
				EventItem(nit)   = Temp
				Temp             = Comment(nic)
				Comment(nic)     = Comment(nit)
				Comment(nit)     = Temp
				Temp             = Repeat(nic)
				Repeat(nic)      = Repeat(nit)
				Repeat(nit)      = Temp
				Temp             = Acknowledge(nic)
				Acknowledge(nic) = Acknowledge(nit)
				Acknowledge(nit) = Temp
			End If
		Next
	Next
End Sub


'-------------------------------------------------------
'- Agenda Item GUI Panel Functions ---------------------
'-------------------------------------------------------
'- Close GUI Panel. Commando in Exit list van GUI ------
'-------------------------------------------------------
Sub GUI_Close_Panel()
Dim objProcess
Dim strProcessKill 

	Select Case GetPropertyValue ("Agenda.GUI OK_Cancel")
		Case "OK"    : GUI_OK_Item()
		Case "Cancel": SetPropertyValue "Agenda.Previous Action", "" 'Agenda (task) kan hierdoor weer gaan checken
		Case Else    : SetPropertyValue "Agenda.Previous Action", ""
	End Select

	'Call Refresh_Icons()
	Call Set_Month_Image(GetPropertyValue ("Agenda.Year"), GetPropertyValue ("Agenda.Month"), GetPropertyValue ("Agenda.Day"))
	
	strProcessKill = "'Click-N-Type.exe'" 
	For Each objProcess In GetObject ("winmgmts:").InstancesOf ("Win32_Process Where Name = " & strProcessKill)
		objProcess.Terminate()
	Next
End Sub


'-------------------------------------------------------
'- Open GUI Panel to edit selected item ----------------
'-------------------------------------------------------
Sub GUI_Edit_Item()
Dim Data
Dim ItemNr_YMD

	Data = Split(GetPropertyValue("Agenda.Day Log Selected Item Line"), "#")
	If IsNumeric(Data(0)) Then
		'ExecuteRemoteApp "C:\Program Files\Click-N-Type\Click-N-Type.exe", ""
		SetPropertyValue "Agenda.GUI OK_Cancel", "Cancel"
		SetPropertyValue "Agenda.Previous Action", "Change_Item" 'Agenda (task) stopt hierdoor met checken
		ItemNr_YMD = Data(0) & "#" & Data(1) & "#" & Data(2) & "#" & Data(3)
		SetPropertyValue "Agenda.GUI ItemNr_YMD", ItemNr_YMD
		SetPropertyValue "Agenda.GUI Hour", Data(4)
		SetPropertyValue "Agenda.GUI Minute", Data(5)
		SetPropertyValue "Agenda.GUI Comment", Data(7)
		Call GUI_Item("GUI_Item_" & Data(6))
		Call GUI_Repeat("GUI_Repeat_" & Data(8))
		SetPropertyValue "Agenda.GUI Status", "Edit geselecteerd item. Druk 'Nieuw Item' om een nieuw item te maken."
	Else
		SetPropertyValue "Agenda.GUI Status", "Geen item geselecteerd -> Nieuw Item"
		Call GUI_New_Item(True)
	End If
End Sub


'-------------------------------------------------------
'- Open GUI Panel to create new item -------------------
'-------------------------------------------------------
Sub GUI_New_Item(Change_Entry)
Dim ItemNr_YMD

	SetPropertyValue "Agenda.GUI OK_Cancel", "Cancel"
	SetPropertyValue "Agenda.Previous Action", "" 'Agenda (task) kan hierdoor weer gaan checken
	ItemNr_YMD = "-2" & "#" & GetPropertyValue ("Agenda.Year") & "#" & GetPropertyValue ("Agenda.Month") & "#" & getPropertyValue ("Agenda.Day")
	SetPropertyValue "Agenda.GUI ItemNr_YMD", ItemNr_YMD
	SetPropertyValue "Agenda.GUI Hour", "00"
	SetPropertyValue "Agenda.GUI Minute", "00"
	SetPropertyValue "Agenda.GUI Comment", ""
	Call GUI_Item("GUI_Item_Wekker")
	Call GUI_Repeat("GUI_Repeat_0")
	If Change_Entry <> True Then 'Bij True is alleen de Status regel anders
		SetPropertyValue "Agenda.GUI Status", "Nieuw Item"
	End If
End Sub


'-------------------------------------------------------
'- Close GUI Panel and OK new/changed item -------------
'-------------------------------------------------------
Sub GUI_OK_Item()
Dim Data
Dim ItemNr_YMD
Dim intItemNr
Dim strRepeat
Dim intRepeat

	TotalEventLines = Read_ItemList()
	Data            = GetPropertyValue("Agenda.GUI ItemNr_YMD")
	ItemNr_YMD      = Split(Data, "#")
	strRepeat       = GetPropertyValue("Agenda.GUI Repeat")
	Select Case strRepeat
		Case "Geen"   : intRepeat = 0
		Case "Uur"    : intRepeat = 1
		Case "Dag"    : intRepeat = 2
		Case "Week"   : intRepeat = 3
		Case "2 Weken": intRepeat = 4
		Case "Maand"  : intRepeat = 5
		Case "Jaar"   : intRepeat = 6
		Case Else     : intRepeat = 0
	End Select
       	
	If IsNumeric(ItemNr_YMD(0)) and CInt(ItemNr_YMD(0)) <> -2 Then
		intItemNr = ItemNr_YMD(0) 'Hierdoor wordt een item vervangen i.p.v. toegevoegd
	Else
		intItemNr       = TotalEventLines + 1
		TotalEventLines = TotalEventLines + 1 'TotalEventLines is een Globale waarde en moet worden opgehoogd
	End If					      ' om in de Write_ItemList het extra item mee te saven
       	
	ItemNr(intItemNr)      = intItemNr
	Jaar(intItemNr)        = ItemNr_YMD(1)
	Maand(intItemNr)       = ItemNr_YMD(2)
	Dag(intItemNr)         = ItemNr_YMD(3)
	Uur(intItemNr)         = GetPropertyValue("Agenda.GUI Hour")
	Minuut(intItemNr)      = GetPropertyValue("Agenda.GUI Minute")
	EventItem(intItemNr)   = GetPropertyValue("Agenda.GUI Item")
	Comment(intItemNr)     = Replace(GetPropertyValue ("Agenda.GUI Comment"), "#", "*")
	Repeat(intItemNr)      = intRepeat
	Acknowledge(intItemNr) = 0
	Call Write_ItemList()
	SetPropertyValue "Agenda.Previous Action", "" 'Agenda (task) kan hierdoor weer gaan checken
End Sub


'-------------------------------------------------------
'- Set Hour value in GUI Panel -------------------------
'-------------------------------------------------------
Sub GUI_Hour(Action)
Dim Uur

	Uur = CInt(GetPropertyValue ("Agenda.GUI Hour"))
	Select Case Right(Action, 1)
		Case "+": Uur = Uur + 1
			  If Uur >= 24 Then
			  	Uur = 0
			  End If
		Case "-": Uur = Uur - 1
			  If Uur < 0 Then
			  	Uur = 23
			  End If
	End Select
	
	Uur = L_Pad(Uur, 2, "0")
	SetPropertyValue "Agenda.GUI Hour", Uur
End Sub


'-------------------------------------------------------
'- Set Minute value in GUI Panel -----------------------
'-------------------------------------------------------
Sub GUI_Minute(Action)
Dim Minuut

	Minuut = CInt(GetPropertyValue ("Agenda.GUI Minute"))
	Select Case Right(Action, 1)
		Case "+": Minuut = Minuut + 1
			  If Minuut >= 60 Then
			  	Minuut = 0
			  End If
		Case "-": Minuut = Minuut - 1
			  If Minuut < 0 Then
			  	Minuut = 59
			  End If
	End Select
	
	Minuut = L_Pad(Minuut, 2, "0")
	SetPropertyValue "Agenda.GUI Minute", Minuut
End Sub


'-------------------------------------------------------
'- Set Item and Icon values in GUI Panel ---------------
'-------------------------------------------------------
Sub GUI_Item(Action)
Dim DataItem

	DataItem = Split(Action, "_")
	SetPropertyValue "Agenda.GUI Item", DataItem(2)
	SetPropertyValue "Agenda.GUI Icon", GetPropertyValue ("Agenda.Picture Path") & "\Icon_" & DataItem(2) & ".png"
	Select Case DataItem(2)
		Case "Wekker"      : Call GUI_Repeat("GUI_Repeat_0")
		Case "Verjaardag"  : Call GUI_Repeat("GUI_Repeat_6")
		Case "Meterstanden": Call GUI_Repeat("GUI_Repeat_5")
	End Select
End Sub


'-------------------------------------------------------
'- Set Repeat value in GUI Panel -----------------------
'-------------------------------------------------------
Sub GUI_Repeat(Action)
Dim Repeat
Dim strRepeat

	Repeat = Split(Action, "_")
	Select Case Repeat(2)
		Case 0   : strRepeat = "Geen"
		Case 1   : strRepeat = "Uur"
		Case 2   : strRepeat = "Dag"
		Case 3   : strRepeat = "Week"
		Case 4   : strRepeat = "2 Weken"
		Case 5   : strRepeat = "Maand"
		Case 6   : strRepeat = "Jaar"
		Case Else: strRepeat = "Geen"
	End Select

	SetPropertyValue "Agenda.GUI Repeat", strRepeat
End Sub
